/*
 * File         : StoreServer.java
 * Author       : Tomasz Stachowiak
 * Created      : Mon Jun 23 16:36:19 1997
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

import java.net.*;
import java.io.*;

class StoreServer implements Runnable {

  static int BUF_SIZE = 1000;
  static int ACK = 6;

  ServerSocket socket;
  String file_name;

  byte[] buf;

  public StoreServer(int port) {

    buf = new byte[BUF_SIZE];

    try {
      socket = new ServerSocket(port);

    } catch (IOException e) {

      System.out.println("StoreServer: " + e);
    }
  }


  private void getFileName() {
  }

  private void sendAck(Socket s) {

    try {
      DataOutputStream os = new DataOutputStream(s.getOutputStream());
      os.write(ACK);
      os.write(file_name.getBytes().length);
      os.write(file_name.getBytes());
      os.close();
    } catch (IOException e) {

      System.out.println("StoreServer: " + e);
    }
  }

  public void run() {

    while(true) {

      try {
	
	Socket sock = socket.accept();
	
	InputStream is = sock.getInputStream();
	StoreMsg msg = new StoreMsg();
	int length = msg.read(is);
	
	FileName fn = new FileName();
	file_name = fn.get();

	FileOutputStream os = new FileOutputStream(file_name);
	int pos = 0;
	
	while(pos < length) {
	  
	  if(length-pos < BUF_SIZE) {
	  }
	  else {
	    is.read(buf);
	    os.write(buf);
	  }
	}

	is.close();
	os.close();

	sendAck(sock);

	sock.close();

      } catch (Exception e) {

	System.out.println("StoreServer: " + e);
      }
    }
  }
}
